<?php
/* kAlbum v1.1 (20090221)
 * Kazuhito Hagio (C) 2006-2009
 *
 * query : index.php?dir=dir_name&page=page_num
 */

/*** 設定 ***/
define('THIS', 'index.php');  # 埋め込むファイル名 [default: index.php]
define('ROOT', 'photos');     # 画像フォルダ名     [default: photos]
define('WIDTH', 120);         # サムネイルの幅     [default: 120]
define('MAXCOL', 5);          # 最大列数           [default: 5]
define('MAXROW', 2);          # 最大行数           [default: 2]
define('PHPTHUMB', 'phpthumb/phpThumb.php');
                              # phpThumb へのパス  [default: phpthumb/phpThumb.php]
define('ICON', 'folder.png'); # アイコンのパス     [default: 'folder.png']
                              #   ('': 非表示)
define('SORT_TYPE', 1);       # 画像ソート順       [default: 1]
                              #   (0: ソートしない, 1: 昇順, 2: 降順)
/*************/

define('KEY_DIR', 'dir');
define('KEY_PAGE', 'page');

/* 変数初期化 */
$query[KEY_DIR] = '';
$query[KEY_PAGE] = '';

/* クエリ取得 */
$raw_query = $_SERVER['QUERY_STRING'];
if ($raw_query != '') {
	$query_array = explode('&', $raw_query);
	$num = count($query_array);
	for ($i = 0; $i < $num; $i++) {
		$tmp = explode('=', $query_array[$i]);
		if ($tmp[0] == KEY_DIR or $tmp[0] == KEY_PAGE) {
			$query[$tmp[0]] = $tmp[1];
		} else {
			echo "<p>不正な引き数です。query : ".$raw_query."</p>";
			return;
		}
	}
}

if ($query[KEY_DIR] == '') {
	$target_dir = ROOT.'/';
} else {
	$target_dir = ROOT.'/'.$query[KEY_DIR].'/';
}

if ($query[KEY_PAGE] == '') {
	$page = 0;
} else {
	$page = $query[KEY_PAGE] - 1;
}

/* 不正クエリチェック */
if (strpos($query[KEY_DIR], '..') !== false) {
	echo "<p>不正なパスが含まれます。</p>\n";
	return;
}

echo "<h2>Index</h2>\n";

/* 上に戻る */
if ($query[KEY_DIR]) { // ROOT のときは空
	echo '<p>';
	$pos = strrpos($query[KEY_DIR], '/');
	if ($pos === false) {
		echo '<a href="'.THIS.'">上の階層へ</a>';
	} else {
		/* 1 階層削る */
		//$path = substr($query[KEY_DIR], 0, strrpos($query[KEY_DIR], '/'));
		$path = substr($query[KEY_DIR], 0, $pos);
		echo '<a href="'.THIS.'?dir='.$path.'">上の階層へ</a>';
	}
	echo "</p>\n";
}

/* ファイルリスト取得 */
$items = listdir($target_dir);
if ($items === NULL) { // NULL と array() は異なる
	echo "<p>そのようなディレクトリは存在しません。</p>\n";
	return;
}

/* ディレクトリとファイルに分ける */
foreach ($items as $item) {
	if (is_dir($target_dir.$item)) {
		$dirs[] = $item;
	} else {
		$files[] = $item;
	}
}

/* ディレクトリ一覧 */
if (isset($dirs)) {
	echo "<p>\n";
	sort($dirs);
	$num = count($dirs);
	for ($i = 0; $i < $num; $i++) {
		if ($query[KEY_DIR]) {
			$path = $query[KEY_DIR]."/".$dirs[$i];
		} else {
			$path = $dirs[$i];
		}
		if (file_exists(ICON)) {
			$icon = '  <img src="'.ICON.'" alt="-" />';
		}
		echo $icon.'<a href="'.THIS.'?dir='.$path.'">'.$dirs[$i]."</a>&nbsp;\n";
	}
	echo "</p>\n";
}

echo "<hr />\n";

/* 見出し (ディレクトリパス) */
if ($query[KEY_DIR]) {
    echo "<h2>".$query[KEY_DIR]."</h2>\n";
} else {
    echo "<h2>".ROOT."</h2>\n";
}

/* 画像一覧 */
if (!isset($files)) {
	echo "<p>ここにはまだ画像がありません。</p>\n";
	return;
}

/* ソート */
if (SORT_TYPE == 1) {
	sort($files);
} elseif (SORT_TYPE == 2) {
	rsort($files);
}

/* ページリストを表示 */
$num = count($files);
echo pagelist($query[KEY_DIR], $num, $page);

/* サムネイルテーブルを表示 */
echo "<table class=\"album\">\n";
$finished = 0;
for ($i = MAXROW * $page; !$finished and $i < MAXROW * ($page+1); $i++) {
	$imginfo = '';
	echo "<tr>\n";
	for ($j = 0; $j < MAXCOL; $j++) {
		$pos = MAXCOL * $i + $j;
		if (!isset($files[$pos])) {
			$finished = 1;
			break;
		}
		$path = $target_dir.$files[$pos];
		$thumb = '<img src="'.PHPTHUMB.'?src=../'.$path.'&amp;w='.WIDTH.'" width="'.WIDTH.'" />';
		echo '  <td><a href="'.$path.'">'.$thumb.'</a></td>'."\n";

		/* 画像情報 */
		$size = getimagesize($path);
		$kbytes = round(filesize($path) / 1024);

		$imginfo = $imginfo.'  <td>'.$files[$pos].'<br />'.$size[0].' x '.$size[1].' ('.$kbytes.' KB)</td>'."\n";
	}
	echo "</tr>\n";
	echo "<tr>\n".$imginfo."</tr>\n";
}
echo "</table>\n";

echo pagelist($query[KEY_DIR], $num, $page);


/*** 関数定義 ***/

/* ページリストを返す */
function pagelist($dir, $file_num, $cur_page) {
	$numofpages = ceil($file_num / (MAXCOL * MAXROW));
	if ($numofpages > 1) { // 1 ページに収まる場合は表示しない
		$out = '<p>Pages: ';
		for ($i = 0; $i < $numofpages; $i++) {
			if ($i != $cur_page) {
				$out = $out.'<a href="'.THIS.'?dir='.$dir.'&amp;page='.($i+1).'">'.($i+1).'</a> ';
			} else {
				$out = $out.'<b>'.($i+1).'</b> ';
			}
		}
		return $out."</p>\n";
	}
	return '';
}

/* ディレクトリ中のファイルリストを返す (ファイル名のみ) */
function listdir($target_dir) {
	if (!file_exists($target_dir)) {
		return NULL;
	}
	$dh = opendir($target_dir);
	$items = array();
	while (false !== ($item = readdir($dh))) {
		if ($item != "." and $item != "..") {
			$items[] = $item;
		}
	}
	closedir($dh);
	return $items;
}

?>
